/* ScummVM - Scumm Interpreter
 * Copyright (C) 2003-2005 Andreas 'Sprawl' Karlsson - Original EPOC port, ESDL
 * Copyright (C) 2003-2005 Lars 'AnotherGuest' Persson - Original EPOC port, Audio System
 * Copyright (C) 2005 Jurgen 'SumthinWicked' Braam - EPOC/CVS maintainer
 * Copyright (C) 2005 The ScummVM project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * $Header: /cvsroot/scummvm/scummvm/backends/epoc/build/S60/ScummVMApp.h,v 1.1.2.1 2005/10/18 02:11:15 sev Exp $
 */

#ifndef ScummVMapps60h
#define ScummVMapps60h

#include <aknapp.h>
#include <eikapp.h>
#include <e32base.h>
#include <coecntrl.h>
#include <eikenv.h>
#include <coeview.h>
#include <eikappui.h>

class CScummVM:public CEikApplication {
public:
	CScummVM();
	~CScummVM();
	CApaDocument* CreateDocumentL();
	TUid AppDllUid() const;
};


#include <AKNdoc.h>

class CScummVMDoc:public  CAknDocument {
public:
	~CScummVMDoc();
	CEikAppUi* CreateAppUiL();
	void ConstructL();
	CScummVMDoc(CEikApplication& aApplicaiton);
};

#include <aknappui.h>
class CScummVMUi;
class CScummWatcher:public CActive {
public:
	CScummWatcher();
	~CScummWatcher();
	void DoCancel();
	void RunL();
	CScummVMUi* iAppUi;
};

class CScummVMUi:public CAknAppUi {
public:
	CScummVMUi();
	~CScummVMUi();
	void ConstructL();
	void HandleCommandL(TInt aCommand);
	void HandleForegroundEventL(TBool aForeground);
	void BringUpEmulatorL();
private:
	TThreadId iThreadId;
	TInt iExeWgId;
	RThread iThreadWatch;
	CScummWatcher* iWatcher;
};
#endif
